

/*chrome.runtime.onMessage.addListener(function () {
    // Center window on screen.
	
	const pWidth = 700, pHeight = 400;
	
	chrome.windows.getCurrent(function(wind) {
		screenWidth = wind.width;
		screenHeight = wind.height;
	
		chrome.windows.create({
			url: "index.html",
			type: "popup",
			width: pWidth,
			height: pHeight
		}, function(w) {
			chrome.windows.onRemoved.addListener(function (wIndex) {
				if (wIndex === w.id) {
					printJobForm.callBack("OK");
					printJobForm = null;
				}
			});
			
		});
	});
	
});*/

let db;
const request = indexedDB.open("GoPrintDB", 1);

request.onerror = function(event) {
  console.error("Failed to open IndexedDB database", event.target.error);
};
request.onsuccess = function(event) {
  db = event.target.result;
  console.log("Successfully opened IndexedDB database");
};
request.onupgradeneeded = function(event) {
  const db = event.target.result;
  const objectStore = db.createObjectStore("GoPrintStore", { keyPath: "id" });
  console.log("IndexedDB database upgraded");
};

chrome.printerProvider.onGetPrintersRequested.addListener(function (resultCallBack) {

    var printerInfoList = [];

    // create array of PrintInfo
    let count = 0;
    let printerArray = "GoPrint Printer".split(", ");
    printerArray.forEach(function(element) {

        var info = {id: element, name: element};
        printerInfoList.push(info)
        count ++;
    });

    resultCallBack(printerInfoList);

});

const onGetListFinished = xhr => {
    console.log("JSON response from: " + xhr.responseURL + ": \n" + xhr.responseText);
    try {

        let resp = JSON.parse(xhr.responseText);
        console.log("got successful response from:", xhr.responseURL);

        if(resp.success) {

            var printerInfoList = [];

            // create array of PrintInfo
            let count = 0;
            let printerArray = resp.printer.replace("[", "").replace("]", "").split(", ");
            printerArray.forEach(function(element) {

                var info = {id: element, name: element};
                printerInfoList.push(info)
                count ++;
            });

            return printerInfoList;
        } else {
            return []
        }

        return 
    } catch (e) {
        console.warn("Invalid JSON response from:" + xhr.responseURL + "error: " + e);
        return []
    }

};

chrome.printerProvider.onGetCapabilityRequested.addListener((printerId, resultCallback) => {
    console.log("requesting printer capabilities for", printerId);
    
    return resultCallback({
        "version": "1.0",
        "printer": {
            "supported_content_type": [{ "content_type": "application/pdf" }],
            "color": {
                "option": [
                            {"type": "STANDARD_MONOCHROME"},
                            {"type": "STANDARD_COLOR", "is_default": true},
                            {
                              "vendor_id": "ultra-color",
                              "type": "CUSTOM_COLOR",
                              "custom_display_name": "Best Color"
                            }
                          ]
            },
            "duplex": {
                "option": [
                    {"type": "NO_DUPLEX"},
                    {"type": "LONG_EDGE"},
                    {"type": "SHORT_EDGE"}
                ]
            },
            "page_orientation": {
                "option":[
                    {"type": "PORTRAIT", "is_default": true},
                    {"type": "LANDSCAPE", "is_default": false},
                    {"type": "AUTO", "is_default": false}
                ]
            },
            "copies": { "default": 1, "max": 100 },
            "media_size": { 
                "option": [
                    {
                      "name": "NA_LEGAL",
                      "width_microns": 215900,
                      "height_microns": 355600
                    },
                    {
                      "name": "NA_LETTER",
                      "width_microns": 215900,
                      "height_microns": 279400
                    }
                ]
            }
        }
    });
});


let printJobForm;

chrome.printerProvider.onPrintRequested.addListener(function (printJob, resultCallback) {
    updatePrintJobForm(printJob, resultCallback);    
    openPreLogin(printJob);
});

function updatePrintJobForm(printJob, resultCallback) {
    let formData = new FormData();
    formData.append("printerName", printJob.printerId);
    formData.append("copies", printJob.ticket.print.copies ? printJob.ticket.print.copies.copies : 1);
    formData.append("documentName", printJob.title);
    formData.append("color", printJob.ticket.print.color ? printJob.ticket.print.color.type : "AUTO");
    formData.append("duplex", printJob.ticket.print.duplex ? printJob.ticket.print.duplex.type : "NO_DUPLEX");
    formData.append("mediaHeightMicrons", printJob.ticket.print.media_size ? printJob.ticket.print.media_size.height_microns : 0);
    formData.append("mediaWidthMicrons", printJob.ticket.print.media_size ? printJob.ticket.print.media_size.width_microns : 0);
    formData.append("printDocument", printJob.document);
    printJobForm = {form: formData, callBack: resultCallback, printerUrl: printJob.printerId};
}

function openPreLogin(printJob) {
	var screenWidth = 0;
	var screenHeight = 0;
	let urlBase = printJob.printerId;
	const pWidth = 529, pHeight = 536;
	
	chrome.windows.getCurrent(function(wind) {
		screenWidth = wind.width;
		screenHeight = wind.height;
	
		chrome.windows.create({
			url: "pre_login.html",
			type: "popup",
			width: pWidth,
			height: pHeight
		}, function(w) {
			chrome.windows.onRemoved.addListener(function (wIndex) {
				if (wIndex === w.id) {
					printJobForm.callBack("OK");
					printJobForm = null;
				}
			});	

            const transaction = db.transaction(["GoPrintStore"], "readonly");
            const objectStore = transaction.objectStore("GoPrintStore");
            const request = objectStore.get(1);

            request.onsuccess = function(event) {
                const record = event.target.result;

                const transaction = db.transaction(["GoPrintStore"], "readwrite");
                const objectStore = transaction.objectStore("GoPrintStore");

                if(record) {
                    record.value = printJob;
                    const request = objectStore.put(record);
                    request.onsuccess = function(event) {
                        console.log("Successfully stored data in IndexedDB database");
                    }; 
                    
                    request.onerror = function(event) {
                        console.error("Failed to store data in IndexedDB database", event.target.error);
                    }
                } else {
                    const request = objectStore.add({ id: 1, value: printJob });

                    request.onsuccess = function(event) {
                      console.log("Successfully stored data in IndexedDB database");
                    };
                    request.onerror = function(event) {
                        console.error("Failed to store data in IndexedDB database", event.target.error);
                    };
                }
            }

            request.onerror = function(event) {
                console.error("Failed to get record from the IndexedDB database", event.target.error);
            }
			
			//chrome.windows.contentWindow.printJob = printJob;
			//chrome.windows.contentWindow.urlBase = urlBase;
		
		});
		/*chrome.windows.create('upload.html', {
			id: "upload-screen",
			frame: "none",
			resizable: false,
			outerBounds: {
				width: width,
				height: height,
				left: Math.round((screenWidth - width) / 2),
				top: Math.round((screenHeight - height) / 2)
			}
		}, newWindow => {
			newWindow.onClosed.addListener(() => {
				printJobForm.callBack("OK");
				printJobForm = null;
			});
			newWindow.contentWindow.printJob = printJob;
			newWindow.contentWindow.urlBase = urlBase;
		});*/
	});
	
    
}
