(function () {

	document.title = "GoPrint Driver Settings";

	const saveSettings = function() {
		$("#loading").modal('show');

		var endPoint = $("#endPoint").find(":selected").val();
		//var useHttps = $("#useHttps:checked").length == 1 ? "true" : "false";
		var deviceID = $("#deviceID").val();

		if(endPoint.length > 0 && deviceID.length > 0) {
			chrome.storage.local.set({"endPoint": endPoint});
			chrome.storage.local.set({"deviceID": deviceID});
			//chrome.storage.local.set({"useHttps": useHttps});

			getDevice(endPoint, deviceID);

		}

	};

	const getDevice = function(endpoint, deviceID) {
		const getDeviceRequest = () => {
	        return new Promise((resolve, reject) => {

	        	if(endpoint != undefined
	        		&& deviceID != undefined
	        		&& deviceID.length > 0) {

		            var formData = new FormData();
		            formData.append("deviceID", deviceID);

		            let xhr = new XMLHttpRequest();

		            xhr.addEventListener("readystatechange", function() {
				  		if(this.readyState === 4) {
				    		console.log(this.responseText);
				  		}
					});

		            try {
		                xhr.open("POST", endpoint + "/netzcore/location/service/printerByID");
		            } catch (e) {
		                console.log("Ignoring invalid url: " + endpoint);
		            }

		            xhr.timeout = 45000;
		            xhr.onload = function () {

		                if (xhr.status >= 200 && xhr.status < 300) {
		                    var success = onGetDeviceFinished(xhr);

		                    resolve(success);

		                } else {
		                    console.log("request to " + endpoint + " failed", this.status, xhr.statusText);
		                	resolve("request_failed");
		                	$("#endpointNotFound").modal('show');
		                }
		            };
		            xhr.ontimeout = function (e) {
		                console.log("timed out", this.status, xhr.statusText);
		                resolve("timed_out");
		                $("#endpointNotFound").modal('show');
		            };
		            xhr.onerror = function (e) {
		                console.log("request failed", this.status, xhr.statusText);
		                resolve("request_failed");
		                $("#endpointNotFound").modal('show');
		            };


		            xhr.send(formData);
		        } else {
		        	resolve("");
		        }

	        });
	    }

	    getDeviceRequest().then(values => {
	        

			if(values !== "request_failed") {

			    // Extract the list from the JSON object
			    var printer = values.printer;

		        // Set the result popup fields
	            if(printer != undefined) {
					chrome.storage.local.set({"printer": printer});

	        		$("#deviceNotFound").modal('hide');

					chrome.runtime.sendMessage("refreshSettings");
					setTimeout(()=>{
						$("#loading").modal('hide');
						window.close();
					}, 100);

	            } else {
					$("#loading").modal('hide');
	        		$("#deviceNotFound").modal('show');
	            }

	        } else {
				$("#loading").modal('hide');
	        	$("#deviceNotFound").modal('show');
	        }
		});
	};

	const setSettings = function() {

		$("#dialog-ok").click(function() {
			saveSettings();
		});

		chrome.storage.local.get(['endPoint'], function(result) {
			if(result.endPoint === undefined) {
				$("#endPoint option[value='https://portal.goprint.cloud']").attr('selected', 'selected');
			} else {
				$("#endPoint option[value='" + result.endPoint + "']").attr('selected', 'selected');
			}
			
		});

		chrome.storage.local.get(['deviceID'], function(result) {
			if(result.deviceID === undefined) {
				$("#deviceID").val("");
			} else {
				$("#deviceID").val(result.deviceID);
			}
			
		});

		/*chrome.storage.local.get(['useHttps'], function(result) {
			if(result.useHttps == 'true') {
				$("#useHttps").prop('checked', true);
			} else {
				$("#useHttps").prop('checked', false);
			}
		});*/


	};

	const onGetDeviceFinished = xhr => {
	    console.log("JSON response from: " + xhr.responseURL + ": \n" + xhr.responseText);
	    try {

	        return JSON.parse(xhr.responseText);
            
	    } catch (e) {
	        console.warn("Invalid JSON response from:" + xhr.responseURL + "error: " + e);
	        return "invalid response";
	    }

	};

	setSettings();

})();