let serverURL;
//let isHTTPS;
let serverDeviceID;
let serverUploadURL;
const uploadURL = "/netzcore/cloudprinting/uploadfile";
let printJob;
let username;
let passcode;
let printer;

(function () {

	const initialise = function() {

		document.title = "GoPrint Driver";

	    chrome.storage.local.get(['username'], function(result) {
			if(result.username !== undefined && result.username !== "") {
				
				console.log("result.username: " + result.username);

				$("#username").val(result.username);

			    chrome.storage.local.get(['passcode'], function(result) {
					if(result.passcode !== undefined && result.passcode !== "") {
						$("#passcode").val(result.passcode);

						console.log("result.passcode: " + result.passcode);

						$("#username-and-password").hide();

						$("#file-name-wrap").css("margin-top", "120px");
					}
				});
			} else {
				$("#file-name-wrap").css("margin-top", "0");
				$("#username-and-password").show();
				/*chrome.identity.getProfileUserInfo(function(userInfo) {
					$("#username").val(userInfo.email);
				});*/
			}
		});

		chrome.storage.local.get(['printer'], function(result) {
			printer = result.printer;

			if(printer != undefined) {
				
				$("#username").attr('placeholder', printer.printNamePrompt);
				$('input[type="password"]').attr('placeholder', printer.passCodePrompt);

				if(printer.showPassCode) {
					$("#mandatoryFieldsMsg").html(printer.printNamePrompt + " and " + printer.passCodePrompt + " are required");
					$("#passcode-field").show();
				} else {
					$("#mandatoryFieldsMsg").html(printer.printNamePrompt + " is required");
					$("#passcode-field").hide();
				}
			}
		});

	    chrome.storage.local.get(['endPoint'], function(result) {
			if(result.endPoint === undefined) {
				serverURL = "https://portal.goprint.cloud";
				chrome.storage.local.set({"endPoint": serverURL});
			} else {
				serverURL = result.endPoint;
			}
		});

		chrome.storage.local.get(['deviceID'], function(result) {
			if(result.deviceID === undefined) {
				serverDeviceID = "95674931";
				chrome.storage.local.set({"deviceID": serverDeviceID});
			} else {
				serverDeviceID = result.deviceID;
			}
		});

		/*chrome.storage.local.get(['useHttps'], function(result) {
			if(result.useHttps == 'true') {
				isHTTPS = true;
			} else {
				isHTTPS = false;
			}
		});*/

		$(document).keyup(function (event) {
            if (event.keyCode == 27) {
                window.close();
            }
        });

        $("#failDialog").on("shown.bs.modal", function() {
    		$("#loading").modal('hide');
        });

        $("#failDialogWithReason").on("shown.bs.modal", function() {
    		$("#loading").modal('hide');
        });

        $("#timeOutDialog").on("shown.bs.modal", function() {
    		$("#loading").modal('hide');
        });

        $("#bt-settings").click(function() {
        	let screenWidth = screen.availWidth;
		    let screenHeight = screen.availHeight;
			const pWidth = 320, pHeight = 300;

			chrome.windows.getCurrent(function(wind) {
				screenWidth = wind.width;
				screenHeight = wind.height;
			
				chrome.windows.create({
					url: "settings.html",
					type: "popup",
					width: pWidth,
					height: pHeight
				});
			});	
	
			chrome.runtime.onMessage.addListener(
		    	function(request, sender, sendResponse) {
		    		if(request == "refreshSettings") {
		    			openPreLoginScreen();
		    		}
				}
			);

        });

        $("#username").focus();
	};

	const uploadFile = function() {

		const uploadRequest = () => {
	        return new Promise((resolve, reject) => {


	        	if(serverURL != null 
	        		&& serverURL.length > 0 
	        		&& serverDeviceID != null
	        		&& serverDeviceID.length > 0) {

		            var formData = new FormData();
		            formData.append("SecureID", "6YDRStq5RDs5jYGx");
		            formData.append("SecureKey", "dS8F2e");
		            formData.append("SiteCode", serverDeviceID);
		            var printTitle = printJob.title.replace(/ /g, "_");
		            var arrPrintTitle = printTitle.split(".");

	            	if(arrPrintTitle[arrPrintTitle.length - 1] != "pdf") {
	            		printTitle = "";
	            		for(var i = 0; i < arrPrintTitle.length - 1; i++) {
	            			printTitle += arrPrintTitle + ".";
	            		}

	        			if(arrPrintTitle.length == 1) {
	        				printTitle = arrPrintTitle[0] + ".pdf";
	        			} else {
	            			printTitle += "pdf";
	        			}
	            	}

		            var file = new File([printJob.document], printTitle, {type: "application/pdf"});
		            formData.append("File", file);
		            formData.append("PrintName", $("#username").val().replace(/</g, "&lt;").replace(/>/g, "&gt;"));
		            formData.append("PassCode", $("#passcode").val().replace(/</g, "&lt;").replace(/>/g, "&gt;"));		            
		            formData.append("Copies", printJob.ticket.print.copies.copies.toString());
		            formData.append("Duplex", printJob.ticket.print.duplex.type == "NO_DUPLEX" ? "false" : "true");
		            formData.append("Color", printJob.ticket.print.color.type == "STANDARD_COLOR" ? "true" : "false");

					serverUploadURL = serverURL + uploadURL;

		            let xhr = new XMLHttpRequest();
		            //xhr.withCredentials = true;

		            xhr.addEventListener("readystatechange", function() {
				  		if(this.readyState === 4) {
				    		console.log(this.responseText);
				  		}
					});

		            try {
		                xhr.open("PUT", serverUploadURL);
		            } catch (e) {
		                console.log("Ignoring invalid url: " + serverUploadURL);
		            }

		            xhr.timeout = 45000;
		            xhr.onload = function () {

		            	let db;
						const request = indexedDB.open("GoPrintDB", 1);

						request.onerror = function(event) {
						  	console.error("Failed to open IndexedDB database", event.target.error);
						};
						request.onsuccess = function(event) {
						 	 db = event.target.result;
						  	console.log("Successfully opened IndexedDB database");

						  	const transaction = db.transaction(["GoPrintStore"], "readwrite");
							const objectStore = transaction.objectStore("GoPrintStore");

							objectStore.delete(1);
						};


		                if (xhr.status >= 200 && xhr.status < 300) {
		                    var success = onUploadFinished(xhr);

		                    resolve(success);

		                } else {
		                    console.log("request to " + serverUploadURL + " failed", this.status, xhr.statusText);
		                	resolve("request_failed");
		                	$("#failDialog").modal('show');
		                }
		            };
		            xhr.ontimeout = function (e) {
		                console.log("timed out", this.status, xhr.statusText);
		                resolve("timed_out");
		                $("#failDialog").modal('show');
		            };
		            xhr.onerror = function (e) {
		                console.log("request failed", this.status, xhr.statusText);
		                resolve("request_failed");
		                $("#failDialog").modal('show');
		            };


		            xhr.send(formData);
		        } else {
		        	resolve("");
		        }

	        });
	    }
	    
	    uploadRequest().then(values => {
	        
			$("#loading").modal('hide');
	        // Set the result popup fields
            if(values.success) {
				$("#successDialog").modal('show');
				$("#dialog-username").text(values.UserName);
				$("#dialog-print-title").text(values.DocumentTitle);
				$("#dialog-total-pages").text(values.TotalPages);
				$("#dialog-color-pages").text(values.ColorPages);
				$("#dialog-copies").text(values.Copies);
				$("#dialog-total-cost").text("$ " +values.TotalCost);
            } else if(values == "timed_out"){
            	$("#timeOutDialog").modal('show');
            } else {
            	if(values != undefined && values.note !== undefined) {
            		$("#failDialogWithReason").modal('show');
            		$("#errorMessage").html(values.note);
            	} else {
            		$("#failDialog").modal('show');
            	}
				
            }
        });
		
	};

	const setFields = function() {
		chrome.windows.getCurrent(function(wind) {

			let db;
			const request = indexedDB.open("GoPrintDB", 1);

			request.onerror = function(event) {
			  	console.error("Failed to open IndexedDB database", event.target.error);
			};
			request.onsuccess = function(event) {
			 	 db = event.target.result;
			  	console.log("Successfully opened IndexedDB database");

			  	const transaction = db.transaction(["GoPrintStore"], "readonly");
				const objectStore = transaction.objectStore("GoPrintStore");
				const requestStore = objectStore.get(1);

				requestStore.onsuccess = function(event) {
				  	console.log("Successfully retrieved data from IndexedDB database:", requestStore.result.value);

					printJob = requestStore.result.value;

					$("#file-name").text(printJob.title);
					$("#upload").click(function() {
						if($("#username").val() === "" || (printer.showPassCode && $("#passcode").val() === "")) {
				    		$("#mandatoryFieldsDialog").modal('show');
					    } else {
							$("#loading").modal('show');
							uploadFile();
						}
					});
					$('#successDialog').on('hidden.bs.modal', function () {
						window.close();
					});
					$('#failDialog').on('hidden.bs.modal', function () {
						$("#loading").modal('hide');
					});

				};
				requestStore.onerror = function(event) {
				  console.error("Failed to retrieve data from IndexedDB database", event.target.error);
				};
			};
			request.onupgradeneeded = function(event) {
			  const db = event.target.result;
			  const objectStore = db.createObjectStore("GoPrintStore", { keyPath: "id" });
			  console.log("IndexedDB database upgraded");
			};


			

			/*chrome.storage.local.get(['printJob'], function(result) {
				printJob = result.printJob;

				$("#file-name").text(printJob.title);
				$("#upload").click(function() {
					$("#loading").modal('show');
					uploadFile();
				});
				$('#successDialog').on('hidden.bs.modal', function () {
					window.close();
				});
				$('#failDialog').on('hidden.bs.modal', function () {
					$("#loading").modal('hide');
				});
			});*/
        });
	};

	const onUploadFinished = xhr => {
	    console.log("JSON response from: " + xhr.responseURL + ": \n" + xhr.responseText);
	    try {

	        return JSON.parse(xhr.responseText);
            
	    } catch (e) {
	        console.warn("Invalid JSON response from:" + xhr.responseURL + "error: " + e);
	        return "invalid response";
	    }

	};

	const openUploadScreen = function() {
		let screenWidth = screen.availWidth;
		    let screenHeight = screen.availHeight;
			const pWidth = 529, pHeight = 536;

			chrome.windows.getCurrent(function(wind) {
				screenWidth = wind.width;
				screenHeight = wind.height;
			
				chrome.windows.create({
					url: "upload.html",
					type: "popup",
					width: pWidth,
					height: pHeight
				});

				window.close();
			});
		};

	const openUserScreen = function() {
		let screenWidth = screen.availWidth;
	    let screenHeight = screen.availHeight;
		const pWidth = 529, pHeight = 536;

		chrome.windows.getCurrent(function(wind) {
			screenWidth = wind.width;
			screenHeight = wind.height;
		
			chrome.windows.create({
				url: "login.html",
				type: "popup",
				width: pWidth,
				height: pHeight
			});

			window.close();

		});
	}

	const openPreLoginScreen = function() {
		let screenWidth = screen.availWidth;
	    let screenHeight = screen.availHeight;
		const pWidth = 529, pHeight = 536;

		chrome.windows.getCurrent(function(wind) {
			screenWidth = wind.width;
			screenHeight = wind.height;
		
			chrome.windows.create({
				url: "pre_login.html",
				type: "popup",
				width: pWidth,
				height: pHeight
			});

			window.close();
		});
	};


	initialise();
    setFields();

})();